//
//  ___FILENAME___
//  ___PACKAGENAME___
//
//  Created by ___FULLUSERNAME___ on ___DATE___.
//___COPYRIGHT___
//

import Foundation
import CoreFoundation
import CoreServices
import QuickLook


@_cdecl("GenerateThumbnailForURL")
func GenerateThumbnailForURL(thisInterface:UnsafeRawPointer,
                                            thumbnail: QLThumbnailRequest,
                                            url: CFURL,
                                            contentTypeUTI: CFString,
                                            options: CFDictionary,
                                            maxSize: CGSize) -> OSStatus
{
    autoreleasepool
    {
        // このプラグインのバンドルが取れる。
        // QLThumbnailRequestGetGeneratorBundle(thumbnail).takeRetainedValue()
        
        if QLThumbnailRequestIsCancelled(thumbnail) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
        
        // ファイルの読み込みをここら辺で行う
        
        if QLThumbnailRequestIsCancelled(thumbnail) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
        
        // 読み込んだファイルのデータをもとに表示内容を作る
        let theData: CFData = "テスト用の適当な文字列".data(using: String.Encoding.utf8)! as CFData
        
        if QLThumbnailRequestIsCancelled(thumbnail) { return } // キャンセル処理：autoreleasepoolのスコープを抜ける
        
        let theProperties: CFDictionary = [
            kQLPreviewPropertyTextEncodingNameKey: "UTF-8",
            kQLPreviewPropertyAttachmentsKey: [:],
            kQLPreviewPropertyMIMETypeKey: "text"
            ] as CFDictionary
        
        QLThumbnailRequestSetThumbnailWithDataRepresentation(thumbnail,
                                                             theData,
                                                             kUTTypePlainText,
                                                             [:] as CFDictionary,
                                                             theProperties)

        print("Thumbnail in Swift");
    }
    
    return noErr
}

@_cdecl("CancelThumbnailGeneration")
func CancelThumbnailGeneration(thisInterface:UnsafeRawPointer,
                               thumbnail: QLThumbnailRequest) -> Void
{
    // Implement only if supported
}

