//
//  ___FILENAME___
//  ___PACKAGENAME___
//
//  Created by ___FULLUSERNAME___ on ___DATE___.
//  ___COPYRIGHT___
//

import Foundation
import CoreFoundation
import CoreServices

@_cdecl("GetMetadataForFile")
func GetMetadataForFile(    thisInterface:  UnsafeRawPointer,
                            attributes:     CFMutableDictionary,
                            contentTypeUTI: CFString,
                            pathToFile:     CFString) -> DarwinBoolean
{
    var theResult: DarwinBoolean = false
    
    autoreleasepool
    {
        let theContentTypeUTI: String = contentTypeUTI as String

        switch theContentTypeUTI
        {
            case "YOUR_STORE_FILE_UTI":
                theResult = true
            
                // !!TODO!!: CFStringをretainしないで作り出す必要(Copy)があるのでは？attributesが呼び出し側からくるので安全なのか？
                let theTextContent: CFString = "内容物" as CFString
                
                CFDictionaryAddValue(attributes,
                                     unsafeBitCast(kMDItemTextContent,
                                                   to: UnsafeRawPointer.self),
                                     unsafeBitCast(theTextContent,
                                                   to: UnsafeRawPointer.self))

            default:
                theResult = false
        }
    }
    
    
    return theResult
}
