//
//  SQTDViewController.swift
//  SQToDo
//
//  Created by narita on 2018/05/06.
//  Copyright © 2018年 narita. All rights reserved.
//

import Cocoa

class SQTDViewController: NSViewController
{
    // MARK: - class methods
    
    // MARK: - init methods
    
    // MARK: - dealloc
    
    // MARK: - NSCopying, hash, isEqual:
    
    // MARK: - NSCoding methods
    
    // MARK: - restorableState methods
    
    // MARK: - life cycle methods

    override func viewDidLoad()
    {
        super.viewDidLoad()

        // Do any additional setup after loading the view.
    }

    // MARK: - action methods

    @IBAction func addItem(_ sender: Any?)
    {
        self.arrayController?.add(sender)

        self.document?.updateChangeCount(NSDocument.ChangeType.changeDone)
    }
    
    @IBAction func removeItem(_ sender: Any?)
    {
        self.arrayController?.remove(sender)

        self.document?.updateChangeCount(NSDocument.ChangeType.changeDone)
    }

    // MARK: - event handling methods

    // MARK: - drawing methods
    
    // MARK: - delegate/datasource methods

    // MARK: - accessor methods (in pairs)
    
    override var representedObject: Any?
    {
        didSet
        {
            // Update the view, if already loaded.
        }
    }
    
    @IBOutlet var tableView: NSTableView?

    @IBOutlet var arrayController: NSArrayController?
    
    @objc class func keyPathsForValuesAffectingWindow() -> Set<String>
    {
        return [ "view", "view.window" ]
    }
    
    @objc open var window: NSWindow?
    {
        return self.view.window
    }
    
    @objc class func keyPathsForValuesAffectingWindowController() -> Set<String>
    {
        return [ "view", "view.window", "view.window.windowController" ]
    }
    
    @objc open var windowController: NSWindowController?
    {
        return self.window?.windowController
    }
    
    @objc class func keyPathsForValuesAffectingDocument() -> Set<String>
    {
        return [ "view", "view.window", "view.window.windowController",
                 "view.window.windowController.document" ]
    }
    
    @objc open var document: NSDocument?
    {
        return self.windowController?.document as! NSDocument?
    }

    // MARK: - Utility methods

}

